<?php
class base {
/**********************
* 函數功能: 設定相關變數
* 相關語法: SetUp()
**********************/
function Setup(){
	//連結基本url
	$this->baselink ="?func=$this->func";
	//組合成上傳檔案-相關變數
	$this->data_path = DATA_PATH.$this->data_path;//放上傳檔案的目錄;
	$this->data_url  = DATA_URL.$this->data_url;    //上傳檔案的的url;
	$this->html_path = FUNC_PATH.$this->html_path;//放html的目錄;
	$this->lang_path = FUNC_PATH.$this->lang_path;
	//管理權
	$this->admin=(AdminCheck($this->func))?1:"";
	//上傳資料 檢查

	if (count($this->files) >0) {
		
		 if(!is_dir($this->data_path)){
			 $Msg ="<li> 設定錯誤！未設定放資料的 $this->data_path  </li>";
		 }
		 if (!is_writable($this->data_path)) {
			 $Msg .="<li> 設定錯誤！$this->data_path 未能有讀寫權限 </li>";
		 }
		if ($Msg) {
			echo $Msg;
			exit;			
		}
	}
	//群組&個人帳號;
	$this->userID = UserInfo('r','uid');//個人代號
	$this->unitID = UserInfo('r','gid');  //群組代號
	//相關語言檔
} // end of function Setup()



/*******************
* 函數功能: 設定-html樣版檔
* 相關語法: setHtml()
**************************/
function setHtml($act_name,$html_file){
	$this->htmls[$act_name]=$html_file;
	//語言檔的設定
}// end of function setHtml()
/*******************
* 函數功能: 設定-html樣版檔
* 相關語法: setHtml()
**************************/
function getHtml($act){
	$html=$this->htmls[$act];
	$html_file= $this->html_path."/$html";
	if (is_file($html_file)) {
	    return ($html_file);
	}else {
	    return false;
	}
}// end of function getHtml()
/**********************
* 函數功能 ： 程式進入點 -無類別
* 相關語法 ： CaseAct()
**********************/ 
function CaseAct(){ 
	$act=$_REQUEST[act];
	$num=$_REQUEST[$this->indexkey];
	//$tools=NEW TOOLS;
	//$db =NEW DB;
	switch($act) {
		case "AddForm":// 新增表單 
			$this->act='InsertData';//呼叫->Insert的程式
			$this->AddForm();
			break;
		case "EditForm":// 編輯表單 
			$this->act='UpdateData';//呼叫->Update的程式
			$this->EditForm($num);
			break;
		case "ShowForm":// 秀出表單 
			$this->ShowForm($num);
			break;
		case "SearchForm":// 搜尋表單 
			$this->act='SearchData';//呼叫->SearchData的程式
			$this->SearchForm();
			break;
		case "InsertData":// 資料-Insert 
			$this->act='AdminData';
			$this->InsertData();
			break;
		case "UpdateData":// 資料-Update 
			$this->act='AdminData';
			$this->UpdateData($num);
			break;
		case "DeleteData":// 資料-Delete 
			$this->DeleteData($num);
			break;
		case "SearchData":// 搜尋列表 
			$this->act='SearchData';
			$this->SearchData();
			break;
		case "ListData":// 全部列表 
			$this->act='ListData';
			$this->ListData();
			break;
		case "AdminData":// 管理列表 
			$this->act='AdminData';
			$this->AdminData();
			break;
		default: //預設值
			$this->act='ListData';
			$this->ListData();
	}
}//end of function CaseAct()

/********************** 
* 函數功能: 一般導覽列 
* 相關語法: MenuLink()
* @return string 管理導覽列字串
**********************/ 

function MenuLink(){
   // $str .="| <a href=$this->baselink&act=SearchForm>搜尋表單</a>"; 
    $str .="| <a href=$this->baselink&act=ListData AccessKey='c'>全部列表</a>"; 
    if($this->admin){
		$str .="| <a href=$this->baselink&act=AddForm AccessKey='c'>新增表單</a>";
	    $str .="| <a href=$this->baselink&act=AdminData AccessKey='c'>管理列表</a>"; 
		$str .="| <a href=".$_SERVER['PHP_SELF']."?func=admin AccessKey='c'>主管理區</a>";
	}
	$str .="| <br>"; 
    return $str;     
} // end of function  MenuLink()

/********************** 
* 函數功能: 管理導覽列 
* @param  integer $id 索引值
* @param  $option 額外的連結url
* @return string 管理導覽列
* 相關語法: AdminLink($id,$option="") 
**********************/ 
function AdminLink($id){ 
    if(!$this->admin)return false;
	$str  ="[<a href='$this->baselink&act=EditForm&$this->indexkey=${id}'>編輯</a>]"; 
    $str .="[<a href=$this->baselink&act=DeleteData&$this->indexkey=${id} onClick=\"return confirm('您確定要刪除「編號:${id}」嗎?')\">刪除</a>]"; 
    return $str;     
} // end func AdminLink()

/**********************
* 函數功能: 上、下一筆導覽列 
* @param  integer $id 索引值
* @return string 上、下一筆導覽列
* 相關語法: ShowBar($id)
**********************/
function ShowLink($id){
	$url=$this->baselink."&act=ShowForm";   
	$SQL ="SELECT * FROM $this->table WHERE 1 " ;
	$SQL .=$this->sql_where;
	//下一筆
	$db =NEW DB;	
    $nSQL =$SQL." AND $this->indexkey  < '$id' ORDER BY $this->indexkey DESC LIMIT 0,1" ;
	$db->query ($nSQL);
	while ($nrow = $db->fetch_array()){
		$n_id = $nrow[$this->indexkey];
	}
	//上一筆
	$pSQL =$SQL." AND $this->indexkey  > '$id' ORDER BY $this->indexkey ASC LIMIT 0,1" ;
	$db->query ($pSQL);
	while ($prow = $db->fetch_array()){
		$p_id = $prow[$this->indexkey];
	}
	//相關判斷
	$str ="[";
	$str .=($p_id)?"<a href='".$url."&{INDEXKEY}=$p_id'>上一筆</a>":"上一筆";
	$str .=" ]&nbsp;";
	$str .="[ \n";
	$str .=($n_id)?"<a href='".$url."&{INDEXKEY}=$n_id'>下一筆</a>":"下一筆";
	$str .=" ]&nbsp;";
   return $str;     
} // end func AdminLink()

/**********************
* 函數功能: 顯示分頁導覽列 
* @param  integer $ipage 第幾頁
* @param  integer $all  共幾筆
* @param  integer $option_query 其他url 
**********************/
function ShowPageBar($ipage,$all,$option_query="") {
	$link= $this->baselink."&";
	$pages=(INT)($all/$this->page_limit);
	if($all%$this->page_limit==0) $pages--;

	if($pages<1) return "共<font color=red> $all </font> 筆 ";
	$prevpage=$ipage-1; 
	if($prevpage<0) $prevpage=0;
	$nextpage=$ipage+1;
	if($nextpage>$pages) $nextpage=$pages;
	$pagebar="";
	if($ipage>0) $pagebar.="<a href='$link?".$this->ipage."=0&$option_query'>[第一頁]</a>";
			else $pagebar.="[第一頁]";
	if($ipage>0){
		 $pagebar.="<a href='$link".$this->ipage."=$prevpage&$option_query'>[上一頁]</a>";
	}	 
	else $pagebar.="[上一頁]";		
	if($ipage < $pages) {
		$pagebar.="<a href='$link".$this->ipage."=$nextpage&$option_query'>[下一頁]</a>";
	}	
	else $pagebar.="[下一頁]";
			if($ipage<$pages ) $pagebar.="<a href='$link".$this->ipage."=$pages&$option_query'>[最後頁]</a>";
			else $pagebar.="[最後頁]";
			$tp=9;
			$pi=0;
			$hpages=$pages;
			if($pages>$tp) {
				$htp=(INT)($tp/2);
				$pi=$ipage-$htp;
				if($pi<0) $pi=0; 
				$hpages=$pi+$tp;
				if($hpages >$pages ) { 
				  $hpages=$pages; 
				  $pi=$hpages-$tp;
				 }              	
			}
	for($i=$pi;$i<=$hpages;$i++) {
		if($ipage!=$i) $pagebar.="<a href='$link".$this->ipage."=$i&$option_query'>";
		$pagebar.="[".($i+1)."]";
		if($ipage!=$i) $pagebar.="</a>";
	}
	$str =" 共<font color=red> $all </font>筆 ";
	$str .="頁次:<font color=red>".($ipage+1)."</font>/<font color=red>".($pages+1)."</font>頁 ";
	$str .="<font color=red>". $this->page_limit."</font>筆/頁";	
	return $pagebar.$str;		
}//end func showPageBar

/********************** 
* 函數功能: 新增檔案 
* @param string $id 資料表-索引值
* @param string $file 資料表-表單檔案欄位
* 相關語法: CopyFile($id,$file) 索引值,表單檔案欄位 
**********************/ 
function CopyFile($id,$file,$i=0){ 
    //目錄名稱 
    $dir=$this->data_path;
    //$dir=$this->data_path."/$id";
    //檢查目錄是否存在
    if (!is_dir($dir)) mkdir($dir);
    if($_FILES[$file]['tmp_name'] == '') return false; 

    //上傳檔案 
   //新檔案名稱 -保留檔名
    $names= explode('.',$_FILES[$file]['name']); 
    $last_name =strtolower($names[count($names)-1]);//副檔名並轉小寫 
    $main_name =$names[count($names)-2];//主檔名
   
  // $new_name=date('Ymd-His').'_'.str_replace(' ','',$main_name).".".$last_name; 
   //新檔案名稱 -不保留檔名 
    $new_name=$id."_".date("Ymd-His")."${i}.".$last_name; 
    copy($_FILES[$file]['tmp_name'],$dir."/".$new_name); 
    $db=new DB; 
    $SQL ="UPDATE $this->table SET $file='$new_name' WHERE $this->indexkey = '$id'"; 
    $db->query($SQL); 
    return true; 
}//end CopyFile()
/********************** 
* 函數功能: 檢查單一檔案 
格式、大小
* @param string $file 檔案名稱
* 相關語法: ChkFile($file) 
**********************/ 
function ChkFile($file){ 
    if($_FILES[$file]['tmp_name'] == '') return false; 
    //過濾-檔案大小 
    if($_FILES[$file]['size'] > $this->allow_size*1024) {
		$str  = "檔案大小超過 $this->allow_size KB ";
		$str.= "檔案資料上傳失敗！";
		/*if ($this->ErrorMsg) {
		   echo "<script language=javascript>";
		   echo "Javascript:alert('$this->ErrorMsg')";
		   echo "</script>";
           echo "<script language=javascript>";
           echo "Javascript:history.go(-1)";
           echo "</script>";
 		   
		}
		*/
		   return $str; 
	}

    //過濾-副檔名 
    $names= explode('.',$_FILES[$file]['name']); 
    $last_name =strtolower($names[count($names)-1]);//副檔名並轉小寫 
    if (!in_array($last_name,$this->allow_files)) {
		$str2 = "檔案格式不支援喔！";
		$str2 .= "檔案資料上傳失敗！";
		/*if ($this->ErrorMsg) {
		   echo "<script language=javascript>";
		   echo "Javascript:alert('$this->ErrorMsg')";
		   echo "</script>";
           echo "<script language=javascript>";
           echo "Javascript:history.go(-1)";
           echo "</script>";
 		   
		}*/
		return $str2; 
	}
}//end ChkFile()

/********************** 
* 函數功能: 刪除檔案 
* @param string $id 資料表-索引值
* @param string $file 資料表-表單檔案欄位
* 相關語法: DelFile($id,$file) 索引值,表單檔案欄位 
**********************/ 
function DelFile($id,$file){ 
    //相關設定-start 
    $dir=$this->data_path;//目錄名稱 
    //$dir ="$dir/$id";//資料目錄 
    //相關設定-end
    $db=new DB; 
    //$SQL ="SELECT $file FROM $this->table WHERE $this->indexkey ='$id'";
    //$db->query($SQL);
    while ($row = $db->fetch_array()) {
        $file_name = $row[$file];
        if ($file_name !="" AND is_file($dir."/".$file_name)) {
            unlink("$dir/$file_name");
        }
    }
    $SQL ="UPDATE $this->table SET $file='' WHERE $this->indexkey = '$id'"; 
    $db->query($SQL);
    return true; 
}//end DelFile($id,$file) 

/********************** 
* 函數功能: 秀出檔案
* @param string $id 資料表-索引值
* @param string $file 資料表-表單檔案欄位
* @param string $type 秀出的型式
* 相關語法: ShowFile($id,$file) 表單檔案欄位 
**********************/ 
function ShowFile($id,$file,$show_type=''){ 
	$src=$this->data_path."/$file";//檔案的實際路徑
	$src_url=$this->data_url."/$file";//檔案的連結路徑
	if ($show_type =='') {
	    $show_type=$this->show_type;
	}
    //檢查檔案是否存在
	if (!is_file($src)) return $file;
    //檔案來源 
    $names= explode('.',$file); 
    $lastname =strtolower($names[count($names)-1]);//副檔名並轉小寫 
	if (is_file(IMAGE_PATH."icon/$lastname".".gif")) {
	    $icon = "<img  src=".IMAGE_URL."icon/$lastname".".gif border='0' alt=$file>";
	}
	//檔案大小
	$filesize=filesize($src);
	if ($filesize > 1024*1024) {
		$filesize = sprintf("%01.2f", $filesize/(1024*1024)) ." MB";
	}elseif($filesize > 1000) {
		$filesize = sprintf("%01.2f", $filesize/1024)." KB";
	}else {
		$filesize =$filesize." Byte";
	}
	switch ($show_type) {
		case 'lightbox':
			 $str = "$icon <a ref='lightbox' href='${src_url}'> $file </a>$filesize";
			break;
		case 'icon':
			 $str = "$icon <a href='${src_url}' target='_blank'> $file </a>$filesize";
			break;
		case 'image':
			 $str = "<img ref='lightbox'  src='${src_url}' border=0  alt='$file $filesize'> $filesize";
			break;
		case 'link':
			 $str = "<a href='${src_url}' target='_blank'> $file </a>";
			break;
		case 'sound':
			$str = "<EMBED src='".$this->data_url."/$id/$file"."' width=150 height=44 ShowPositionControls=false volume=0 autostart=false align=center /> ";
			break;
		default:
			 $str = "<a href=".$this->data_url."/$id/$file target='_blank'> $file </a>";
	}
	return $str;
}//end ShowFile()


// 相關函式庫 END -----------------------//
}
?>